/***************************************************************************
 *   Copyright (C) 2007 by Sebastian Jambor                                *
 *   sebastian@momo.math.rwth-aachen.de                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef INPARAMETERUTIL_H
#define INPARAMETERUTIL_H

#include "./inparametergmpzaux.h"
#include "./inparametermodularshortaux.h"

void eea(const IOneParameterModularShortAux& a,
    const IOneParameterModularShortAux& b,
    IOneParameterModularShortAux& s,
    IOneParameterModularShortAux& t);

void polydiv(const IOneParameterModularShortAux& a,
    const IOneParameterModularShortAux& b,
    IOneParameterModularShortAux& q,
    IOneParameterModularShortAux& r);

void polydiv(const INParameterModularShortAux& a,
    const INParameterModularShortAux& b,
    INParameterModularShortAux& q,
    INParameterModularShortAux& r);

void polydiv2(const IOneParameterModularShortAux& a,
    const IOneParameterModularShortAux& b,
    IOneParameterModularShortAux& r);

#endif // INPARAMETERUTIL_H
