/***************************************************************************
 *   Copyright (C) 2004 by Blinkov Yu.A.                                   *
 *   BlinkovUA@info.sgu.ru                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef IC1_H
#define IC1_H

#include "./iwrap.h"


class IC1;
class IC1Interface: public IWrapInterface {
  friend class IC1;

public:
  IC1Interface();
  ~IC1Interface() {}

  IWrap* create(IPoly* a);
  IWrap* create(IWrap& a, int var, unsigned deg);
  IWrap* create();
};

class IC1: public IWrap {
  friend class IC1Interface;

protected:
  IC1(IWrapInterface *r, IPoly *poly);
  IC1(IC1& w, int var, unsigned deg);
  IC1(IWrapInterface *r);

public:
  ~IC1() {}

  bool criterion(IWrap& divisor, ISetT&);
};

#endif // IC1_H

