/***************************************************************************
 *   Copyright (C) 2004 by Blinkov Yu.A.                                   *
 *   BlinkovUA@info.sgu.ru                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef IWITHOUT_H
#define IWITHOUT_H

#include "./iwrap.h"


class IWithout;
class IWithoutInterface: public IWrapInterface {
  friend class IWithout;

public:
  IWithoutInterface();
  ~IWithoutInterface() {}

  IWrap* create(IPoly* a);
  IWrap* create(IWrap& a, int var, unsigned deg);
  IWrap* create();
};

class IWithout: public IWrap {
  friend class IWithoutInterface;
  
protected:
  IWithout(IWrapInterface *r, IPoly *poly);
  IWithout(IWithout& w, int var, unsigned deg);
  IWithout(IWrapInterface *r);

public:
  ~IWithout() {}
  
  bool criterion(IWrap& divisor, ISetT& setT);
};

#endif // IWITHOUT_H

