/***************************************************************************
 *   Copyright (C) 2007 by Sebastian Jambor                                *
 *   sebastian@momo.math.rwth-aachen.de                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef INPARAMETERGMPZAUXTEST_H
#define INPARAMETERGMPZAUXTEST_H

#include <list>

#include <cppunit/TestFixture.h>
#include <cppunit/extensions/HelperMacros.h>

#include "iginvtest.h"

#include "../coeff/inparametergmpzaux.h"

class INParameterGmpZAuxTest: public IGinvTest {
CPPUNIT_TEST_SUITE(INParameterGmpZAuxTest);
CPPUNIT_TEST(testRemoveTrivialFactor);
CPPUNIT_TEST_SUITE_END();
private:

public:
  void setUp();

  void testRemoveTrivialFactor();

  void tearDown();
};

#endif // INPARAMETERGMPZAUXTEST_H
