import ginv

st = ginv.SystemType("Polynomial")
ic = ginv.CoeffInterface("GmpZ", st)
print ic.type()
ic = ginv.CoeffInterface("GmpQ", st)
print ic.type()
ic = ginv.CoeffInterface("ModularShort", st, modularShort=31013)
print ic.type()
ic = ginv.CoeffInterface("OneParameterModularShort", st, parameter=['s'], modularShort=31013)
print ic.type()
print ic.isField()
print ic.isPseudo()
print ic.parameter()
ic = ginv.CoeffInterface("OneParameterGmpZ", st, parameter=['s'])
print ic.type()
#ic = ginv.CoeffInterface("TwoParameterGmpZ", st, parameter=['s', 't'])
#print ic.type()
#ic = ginv.CoeffInterface("TwoParameterModularShort", st, parameter=['s', 't'], modularShort=31013)

c0 = ginv.Coeff(ic)
print c0
print c0.isZero()
c1 = ginv.Coeff(ic, "12123")
print c1
print c1.isOne()
print c1.isOne()
print c0.setOne()
print c1.setZero()

print ginv.Coeff(ic, "1965").gcd(ginv.Coeff(ic, "196196196"))
print ginv.Coeff(ic, "1965") + ginv.Coeff(ic, "196196196")
print ginv.Coeff(ic, "1965") - ginv.Coeff(ic, "196196196")
print ginv.Coeff(ic, "1965") * ginv.Coeff(ic, "196196196")
print ginv.Coeff(ic, "196196196") / -ginv.Coeff(ic, "196")
c0 = ginv.Coeff(ic, "196196196") / -ginv.Coeff(ic, "196")
c0 += ginv.Coeff(ic, "196196196")
print c0
c0 -= ginv.Coeff(ic, "196196196")
print c0
c0 *= ginv.Coeff(ic, "196196196")
print c0
c0 /= -ginv.Coeff(ic, "196196196")
print c0
###################################################
ic = ginv.CoeffInterface("NParameterGmpZ", st, parameter=['s', 't', 'v'])
print ic.type()
print ic.isField()
print ic.isPseudo()
print ic.parameter()
