import ginv

st = ginv.SystemType("Polynomial")
im = ginv.MonomInterface("DegRevLex", st, ['x', 'y'])
ic = ginv.CoeffInterface("ModularShort", st, modularShort=2)
ip = ginv.PolyInterface("PolyList", st, im, ic)
iw = ginv.WrapInterface("CritPartially", ip)
id = ginv.DivisionInterface("Janet", iw)

basis = ginv.basisBuild("TQ", id, \
  ["x*y + x + 1",\
   "x^2 - x",\
   "y^2 - y"])

for p in basis.iterIB():
  print p

