import ginv

st = ginv.SystemType("Polynomial")
im = ginv.MonomInterface("Lex", st, ['x', 'y', 'z'])
ic = ginv.CoeffInterface("GmpZ", st)
ip = ginv.PolyInterface("PolyList", st, im, ic)
print ip.type()

poly1 = ginv.Poly(ip)
print poly1
poly2 = ginv.Poly(ip, "2*y^3 - (4*z^2 + 6*x)^2 - 14")
print poly2
print poly2.length()
print poly2.degree()
print poly2.norm()
print poly2.lm()
print poly2.mult(poly2.lm())
print poly2.lc()
print poly2.mult(poly2.lc())
print poly2.isPp()
print poly2.pp()
print poly2.isPp()
poly2.setZero()
print poly2
# poly2.setOne()
print poly2
poly1 = ginv.Poly(ip, "2*y^3 - (4*z^2 + 6*x)^2 - 14")
print poly1
poly1.prolong(2, 12)
print poly1
poly2 = ginv.Poly(ip, "2*y^3 - 4*z^2 + 6*x")
print poly1.reduction(poly2)

lst = map(lambda i: ginv.Poly(ip, "2*y^3 - 4*z^2 + 6*#".replace("#", im.independ()[i])), range(3))
print lst
lst.sort()
print lst
print cmp(lst[0], lst[1])
print lst[0] <= lst[1]

p0, p1, p2 = lst[0], lst[1], lst[2]
print p0.mult(p1.lm()) + p1*p2 - p0.prolong(2, 12).mult(p1.lc())
print p1
p1 += p2
print p1
p1 -= p2
print p1
p1 *= p2
print p1
print len(p1)

for mc in p1:
  print mc

for (m, c) in p1:
  print m, c

print p1[3]
