import ginv

st = ginv.SystemType("Polynomial")
im = ginv.MonomInterface("DegRevLex", st, ['x', 'y', 'z'])
ic = ginv.CoeffInterface("GmpZ", st)
ip = ginv.PolyInterface("PolyList", st, im, ic)
iw = ginv.WrapInterface("Without", ip)
print iw.type()
iw = ginv.WrapInterface("C1", ip)
print iw.type()
iw = ginv.WrapInterface("CritPartially", ip)
print iw.type()
iw = ginv.WrapInterface("C1C2", ip)
print iw.type()
iw = ginv.WrapInterface("C1C2C3", ip)
print iw.type()
iw = ginv.WrapInterface("C1C2C3C4", ip)
print iw.type()

poly = ginv.Poly(ip, "y^3 - z^2 + x - 1")
w = ginv.Wrap(iw, poly)

print "          lm =", w.lm()
print "    ancestor =", w.ancestor()
print "        poly =", w.poly()
print "       multi =", w.multi()
print "  degProlong =", w.degProlong()
print "   isProlong =", w.isProlong()
print "buildProlong =", w.buildProlong()

