import ginv



st = ginv.SystemType("Polynomial")
im = ginv.MonomInterface("DegRevLexByte", st, ['x', 'c'])
#equations = ['2*c', 'x*c']
#equations = ['2*x*c', '3*x^2*c']
#equations = ['(6*x+1)*c', '(15*x^2+2)*c']
#equations = ['(6*x+1)*c', '(12*x^2-1)*c']
equations = ['(x-7)*c', '9*c']

#st = ginv.SystemType("Polynomial")
#im = ginv.MonomInterface("DegRevLexByte", st, ['x', 'y', 'c'])
#equations = ['16*x*y^2*c', '3*x*y*c', '7*x*c']
#equations = ['(x^2-y^2)*c', '(x-y)*c']
#equations = ['2*x*c', '3*y*c']
#equations = ['(3*x^2+y)*c', '(2*x+y)*c']
#equations = ['(13*x-19)*c', '(46-20*y^2)*c', '(x-y)*c']
#equations = ['(13*x-19)*c', '(46*x-20*y)*c']

#st = ginv.SystemType("Polynomial", module=3)
#im = ginv.MonomInterface("TopDegRevLex", st, ['x', 'c'])
#equations = ['[-25*c, 260*c, (-130*x-195)*c]',
             #'[(-2*x^2+2)*c, (-19+20*x^2)*c, (-10*x^3+10*x-15*x^2+15)*c]',
             #'[(-4*x+6)*c, (40*x-60)*c, (46-20*x^2)*c]']

#st = ginv.SystemType("Polynomial", module=2)
#im = ginv.MonomInterface("PotDegRevLex", st, ['x', 'c'])
#equations = ['[c, c]',
             #'[(x^2-1)*c, 0]',
             #'[2*c, 0]',
             #'[(x-1)*c, 0]']

ic = ginv.CoeffInterface("GmpZZ", st)
ip = ginv.PolyInterface("PolyList", st, im, ic)
iw = ginv.WrapInterface("CritPartially", ip)
id = ginv.DivisionInterface("Janet", iw)

basis = ginv.basisBuild("TQ", id, equations)

for p in basis.iterIB():
  print p

#print "*"*50
#print basis.nf("[0*c, (-2*x + 3)*c, (x^2 - 1)*c]")
#print basis.nf("[(x + 1)*c, -26*c, (13*x + 13)*c]")
#print basis.nf("[5*c, -52*c, (26*x + 39)*c]")

print "         lenghtIB = ", basis.lengthIB()
print "         lenghtGB = ", basis.lengthGB()
print "     numCriterion = ", basis.numCriterion()
print "         numSpoly = ", basis.numSpoly()
print "     numReduction = ", basis.numReduction()
print "         userTime = ", basis.userTime()
print "          sysTime = ", basis.sysTime()
print "         realTime = ", basis.realTime()
print "hilbertPolynomial = ", basis.hilbertPolynomial()

