#include <cppunit/extensions/TestFactoryRegistry.h>
#include <cppunit/ui/text/TestRunner.h>


void iAssert(bool a, const char* file, int line) {
  if (!a) {
  	printf("assert from file: '%s'  line: %d\n", file, line);
    int* p = NULL;
    *p = 5;
  }
}

void iError(const char* msg, const char* file, int line) {
  printf("error %s from file: '%s'  line: %d\n", msg, file, line);
  int* p = NULL;
  *p = 5;
  exit(1);
}

void iMessage(const char* msg, const char* file, int line) {
}

int main(int argc, char** argv) {
  CppUnit::TextUi::TestRunner runner;

  CppUnit::TestFactoryRegistry &registry = CppUnit::TestFactoryRegistry::getRegistry();

  runner.addTest( registry.makeTest() );
  runner.run();
  return 0;
}
