/***************************************************************************
 *   Copyright (C) 2004 by Blinkov Yu.A.                                   *
 *   BlinkovUA@info.sgu.ru                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef DIVISION_H
#define DIVISION_H

#include <Python.h>
#include <structmember.h>

#include "../ginv/division/idivision.h"

struct  DivisionInterface {
  PyObject_HEAD
  IDivisionInterface *divisionInterface;
};

void divisionInterface_dealloc(DivisionInterface *self);
PyObject* divisionInterface_new(PyTypeObject *type, PyObject *args, PyObject *kwds);
int divisionInterface_init(DivisionInterface *self, PyObject *args, PyObject *kwds);
PyObject *divisionInterface_getattr(DivisionInterface *self, char *name);

extern PyTypeObject divisionInterface_type;

#endif // DIVISION_H

