/***************************************************************************
 *   Copyright (C) 2004 by Blinkov Yu.A.                                   *
 *   BlinkovUA@info.sgu.ru                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef SYSTEMTYPE_H
#define SYSTEMTYPE_H

#include <Python.h>
#include <structmember.h>

#include "../ginv/system/isystemtype.h"

struct  SystemType {
  PyObject_HEAD
  ISystemType *systemType;
};

void systemType_dealloc(SystemType *self);
PyObject* systemType_new(PyTypeObject *type, PyObject *args, PyObject *kwds);
int systemType_init(SystemType *self, PyObject *args, PyObject *kwds);
PyObject *systemType_getattr(SystemType *self, char *name);
PyObject* systemType_Type(SystemType *self);
PyObject* systemType_module(SystemType *self);
PyObject* systemType_rightPart(SystemType *self);

extern PyTypeObject systemType_type;

#endif // SYSTEMTYPE_H
